% Lezione 5
% y'+2y=2-exp(-4t)
funz='2-exp(-4*t)-2*y';
f=inline(funz,'t','y');
solution=inline('1+0.5*exp(-4*t)-0.5*exp(-2*t)','t');

T0=0;
T=5;
y0=1;

h=2.^(-2:-1:-7)'; % passo temporale
H=length(h); % Numero passi temporali
M=4; % Numero metodi sviluppati
err=zeros(H,1);
hconv=zeros(H+1,1);
hconverr=zeros(H,1);
horder=zeros(M,1);
labconverr=cell(H,1);
labconv=cell(H+1,1);
for i=1:H
    labconverr{i}=['h=' num2str(h(i))];
    labconv{i}=labconverr{i};
end

labconv{H+1}='Soluzione vera';
laborder=cell(M,1);
laball=cell(M+2,1);
laball2=cell(M+1,1);
hmeth=zeros(M+2,1);
herr=zeros(M+1,1);

col='brgcmy';

mymethods=0;
methods=0;

% ode23
methods=methods+1;
methlab='ode23';
laball{methods+1}=methlab;
laball2{methods}=methlab;
laball{1}='Soluzione vera';

tic
[t y]=ode23(f,[T0 T],y0);
tim=toc;
fprintf('Metodo ode23: N=%i - Tempo=%f\n',length(t),tim)

figure(1)
clf;
set(gcf,'Name','Riepilogo metodi')
subplot(2,1,1)
hmeth(methods+1)=plot(t,y,[col(methods) ':']);
xlabel('t')
ylabel('y')
title(funz)
hold on

ytrue=solution(t);
hmeth(methods)=plot(t,ytrue,'k');
subplot(2,1,2)    
ytrue=solution(t);

herr(methods)=plot(t,y-ytrue,col(methods));
hold on
xlabel('t')
ylabel('Errore y-ytrue')

% Metodo di Eulero

methods=methods+1;
mymethods=mymethods+1;
methlab='Eulero';
laborder{mymethods}=methlab;
laball{methods+1}=methlab;
laball2{methods}=methlab;

figure(10+methods)
clf;
set(gcf,'Name',methlab)
for i=1:H
    tic
    [t y]=myeuler(f,[T0 T],y0,h(i));
    tim=toc;
    subplot(2,1,1)
    hold on
    hconv(i)=plot(t,y,[col(i) '--']);
    ytrue=solution(t);
    subplot(2,1,2)
    hold on
    hconverr(i)=plot(t,y-ytrue,col(i));
    err(i)=max(abs(y-ytrue));
end

subplot(2,1,1)
hconv(H+1)=plot(t,ytrue,'k');
title([funz ' - ' methlab])
xlabel('t')
ylabel('Soluzione')
legend(hconv,labconv,'Location','Best')
subplot(2,1,2)
xlabel('t')
ylabel('Errore y-y_{vera}')
legend(hconverr,labconverr,'Location','Best')

p=polyfit(log(h),log(err),1);

figure(5)
clf;
set(gcf,'Name','Ordine di convergenza')
loglog(h,err,['*' col(mymethods)])
hold on
horder(mymethods)=loglog(h,exp(p(1)*log(h)+p(2)),col(mymethods));

figure(1)
fprintf('Metodo %s: N=%i - Tempo=%f - ordine=%i\n',methlab,length(t),tim,p(1))
subplot(2,1,1)
hmeth(methods+1)=plot(t,y,[col(methods) '--']);
subplot(2,1,2)
herr(methods)=plot(t,y-ytrue,col(methods));

% Metodo di Runge-Kutta 2

methods=methods+1;
mymethods=mymethods+1;
methlab='RK2';
laborder{mymethods}=methlab;
laball{methods+1}=methlab;
laball2{methods}=methlab;

figure(10+methods)
clf;
set(gcf,'Name',methlab)
for i=1:H
    tic
    [t y]=myrk2(f,[T0 T],y0,h(i));
    tim=toc;
    subplot(2,1,1)
    hold on
    hconv(i)=plot(t,y,[col(i) '--']);
    ytrue=solution(t);
    subplot(2,1,2)
    hold on
    hconverr(i)=plot(t,y-ytrue,col(i));
    err(i)=max(abs(y-ytrue));
end

subplot(2,1,1)
hconv(H+1)=plot(t,ytrue,'k');
title([funz ' - ' methlab])
xlabel('t')
ylabel('Soluzione')
legend(hconv,labconv,'Location','Best')
subplot(2,1,2)
xlabel('t')
ylabel('Errore y-y_{vera}')
legend(hconverr,labconverr,'Location','Best')

p=polyfit(log(h),log(err),1);

figure(5)
loglog(h,err,['*' col(mymethods)])
hold on
horder(mymethods)=loglog(h,exp(p(1)*log(h)+p(2)),col(mymethods));

figure(1)
fprintf('Metodo %s: N=%i - Tempo=%f - ordine=%i\n',methlab,length(t),tim,p(1))
subplot(2,1,1)
hmeth(methods+1)=plot(t,y,[col(methods) '--']);
subplot(2,1,2)
herr(methods)=plot(t,y-ytrue,col(methods));

% Metodo di Runge-Kutta 2

methods=methods+1;
mymethods=mymethods+1;
methlab='RK4';
laborder{mymethods}=methlab;
laball{methods+1}=methlab;
laball2{methods}=methlab;

figure(10+methods)
clf;
set(gcf,'Name',methlab)
for i=1:H
    tic
    [t y]=myrk4(f,[T0 T],y0,h(i));
    tim=toc;
    subplot(2,1,1)
    hold on
    hconv(i)=plot(t,y,[col(i) '--']);
    ytrue=solution(t);
    subplot(2,1,2)
    hold on
    hconverr(i)=plot(t,y-ytrue,col(i));
    err(i)=max(abs(y-ytrue));
end

subplot(2,1,1)
hconv(H+1)=plot(t,ytrue,'k');
title([funz ' - ' methlab])
xlabel('t')
ylabel('Soluzione')
legend(hconv,labconv,'Location','Best')
subplot(2,1,2)
xlabel('t')
ylabel('Errore y-y_{vera}')
legend(hconverr,labconverr,'Location','Best')

p=polyfit(log(h),log(err),1);

figure(5)
loglog(h,err,['*' col(mymethods)])
hold on
horder(mymethods)=loglog(h,exp(p(1)*log(h)+p(2)),col(mymethods));

figure(1)
fprintf('Metodo %s: N=%i - Tempo=%f - ordine=%i\n',methlab,length(t),tim,p(1))
subplot(2,1,1)
hmeth(methods+1)=plot(t,y,[col(methods) '--']);
subplot(2,1,2)
herr(methods)=plot(t,y-ytrue,col(methods));

% Metodo di Eulero implicito

methods=methods+1;
mymethods=mymethods+1;
methlab='Eulero implicito';
laborder{mymethods}=methlab;
laball{methods+1}=methlab;
laball2{methods}=methlab;

figure(10+methods)
clf;
set(gcf,'Name',methlab)
for i=1:H
    tic
    [t y]=myeulimp(f,[T0 T],y0,h(i));
    tim=toc;
    subplot(2,1,1)
    hold on
    hconv(i)=plot(t,y,[col(i) '--']);
    ytrue=solution(t);
    subplot(2,1,2)
    hold on
    hconverr(i)=plot(t,y-ytrue,col(i));
    err(i)=max(abs(y-ytrue));
end

subplot(2,1,1)
hconv(H+1)=plot(t,ytrue,'k');
title([funz ' - ' methlab])
xlabel('t')
ylabel('Soluzione')
legend(hconv,labconv,'Location','Best')
subplot(2,1,2)
xlabel('t')
ylabel('Errore y-y_{vera}')
legend(hconverr,labconverr,'Location','Best')

p=polyfit(log(h),log(err),1);

figure(5)
loglog(h,err,['*' col(mymethods)])
hold on
horder(mymethods)=loglog(h,exp(p(1)*log(h)+p(2)),col(mymethods));

figure(1)
fprintf('Metodo %s: N=%i - Tempo=%f - ordine=%i\n',methlab,length(t),tim,p(1))
subplot(2,1,1)
hmeth(methods+1)=plot(t,y,[col(methods) '--']);
subplot(2,1,2)
herr(methods)=plot(t,y-ytrue,col(methods));

% Fine metodi

figure(1)
subplot(2,1,1)
legend(hmeth,laball,'Location','Best')
subplot(2,1,2)
legend(herr,laball2,'Location','Best')

figure(5)
title('Convergenza')
xlabel('Passo [h]')
ylabel('Errore massimo')
legend(horder,laborder,'Location','Best')




