function [t,y]=myrk2(f,interv,y0,h)
% Runge-Kutta ordine 2
o1=1/6; o2=2/6; o3=2/6; o4=1/6;
a2=1/2; a3=1/2; a4=1;
b21=1/2; b32=1/2; b43=1;
t=(interv(1):h:interv(2))';
N=length(t);
y=zeros(N,1);
y(1)=y0;
for i=2:N
   k1=h*f(t(i-1),y(i-1));
   k2=h*f(t(i-1)+a2*h,y(i-1)+b21*k1);
   k3=h*f(t(i-1)+a3*h,y(i-1)+b32*k2);
   k4=h*f(t(i-1)+a4*h,y(i-1)+b43*k3);
   y(i)=y(i-1)+o1*k1+o2*k2+o3*k3+o4*k4;
end